diff --git a/sources/src/main/webapp/js/components/group.js b/sources/src/main/webapp/js/components/group.js
index b515143..e9e1e1d 100644
--- a/sources/src/main/webapp/js/components/group.js
+++ b/sources/src/main/webapp/js/components/group.js
@@ -371,634 +176,273 @@ function Group(props) {
 	 * Any node is called excluded when it is not visible in the viewport but instead in the sidebar.
 	 * @param {boolean} newValue True to set the group as excluded, otherwise false.
 	 */
-	this.setExcluded = function(newValue) {
-		excluded = newValue;
+	set isExcluded(newValue) {
+		super.isExcluded = newValue;
 
-		vertexList.forEach(function(vertex) {
-			vertex.setExcluded(newValue);
+		this._vertexList.forEach(vertex => {
+			vertex.isExcluded = newValue;
 		});
-
-		if (newValue) {
-			// set floater
-			floater = new FloatingPoint;
-			floater.setNode(this);
-			app.sidebarComponent.addFloater(floater);
-
-		} else {
-			// remove floater
-			app.sidebarComponent.removeFloater(floater);
-			delete floater;
-		}
-	};
-
-	/**
-	 * Excludes the group from the viewport. Removes group DOM element and hides its edges. If showIcon is set to True
-     * display icon in all neighbour vertices.
-     * @param {boolean} showIcon True to display icon in all neighbours, False otherwise
-	 */
-	this.exclude = function(showIcon) {
-		this.setExcluded(true);
-		this.remove(true);
-
-		app.viewportComponent.removeGroup(this);
-
-        if(showIcon){
-            showIconClick.bind(this)(null)
-        }
-	};
+	}
 
 	/**
 	 * Includes the group in the viewport. Afterwards, edges related to the group are moved to the current position of the group.
 	 */
-	this.include = function() {
-		this.removeFromSidebarList();
-
-        if(iconsDisplayed) {
-            showIconClick.bind(this)(null);
-        }
-        	
-        this.setExcluded(false);
-		this.remove(false);
-
-		app.viewportComponent.addGroup(this);
+	include() {
+		super.include();
 
 		// set edges' ends
-		var inEdgeList = this.getInEdgeList();
-		inEdgeList.forEach(function(edge) {
-			edge.moveEnd(this.getCenter());
-		}, this);
-
-		var outEdgeList = this.getOutEdgeList();
-		outEdgeList.forEach(function(edge) {
-			edge.moveStart(this.getCenter());
-		}, this);
-	};
-
-	/**
-	 * Hook function used to remove the group from the sidebar list it is located in before it is moved to the viewport.
-	 */
-	this.removeFromSidebarList = Utils.noop;
-
-	/**
-	 * Creates a new DOM element representing the group in memory. The element being created depends on whether the group
-	 * is excluded at the moment. Binds user interactions to local handler functions.
-	 * @returns {Element} depending on whether the group is excluded.
-	 */
-	this.render = function() {
-		rootElement = excluded ? renderExcluded.call(this) : renderIncluded.call(this);
-
-		this.setHighlighted(highlighted);
-
-		return rootElement;
-	};
-
-	/**
-	 * Removes the DOM element representing the group from document.
-	 * @param {boolean} hideEdges True to hide edges of vertices in the group in the viewport. Edges are (almost) never really
-	 * removed but rather hidden for cases when a node is included back in the viewport.
-	 */
-	this.remove = function(hideEdges) {
-		rootElement.remove();
-
-		// hide edges
-		var inEdgeList = this.getInEdgeList();
-		inEdgeList.filter(function(edge) {
-			return !edge.getFrom().isExcluded();
-		}).forEach(function(edge) {
-			edge.setHidden(hideEdges);
+		let inEdgeList = this.inEdgeList;
+		inEdgeList.forEach(edge => {
+			edge.end = this.center;
 		});
 
-		var outEdgeList = this.getOutEdgeList();
-		outEdgeList.filter(function(edge) {
-			return !edge.getTo().isExcluded();
-		}).forEach(function(edge) {
-			edge.setHidden(hideEdges);
+		let outEdgeList = this.outEdgeList;
+		outEdgeList.forEach(edge => {
+			edge.start = this.center;
 		});
-	};
+	}
 
 	/**
 	 * Exports the group to a new, plain JS object.
 	 * @returns {Object} exported group
 	 */
-	this.export = function() {
-		var verticesId = vertexList.map(function(vertex) {
-			return vertex.id;
-		});
-
+	export() {
 		return {
 			id: this.id,
 			name: this.name,
-			verticesId: verticesId,
+			verticesId: this.vertexList.map(vertex => vertex.id),
 			verticesEdgeFromId: [],	// TODO: what to put in here? ids of vertices which outgoing edges are visible in graph
 			verticesEdgeToId: [],	// TODO: what to put in here? ids of vertices which incoming edges are visible in graph
-			position: position,
+			position: this.position,
 		};
-	};
+	}
 
 	/**
-	 * @returns {Element} SVG DOM element.
+	 * @returns {SVGElement} SVG DOM element.
 	 */
-	function renderIncluded() {
-		rootElement = DOM.createSvgElement('svg', {
-			'class': 'node group',
-			'x': position.x,
-			'y': position.y,
+	_renderIncluded() {
+		this._rootElement = DOM.s('svg', {
+			class: 'node group',
+			x: this.position.x,
+			y: this.position.y,
 			'data-id': this.id,
+			onClick: this._onNodeClick.bind(this),
+			onMouseDown: this._onNodeMouseDown.bind(this),
+		}, [
+			DOM.s('rect', {
+				width: this.size.width,
+				height: this.size.height,
+				x: 1,
+				y: 1,
+				fill: this.symbol[1],
+				stroke: 'black',
+				'stroke-width': 1,
+			}),
+			// name
+			DOM.s('foreignObject', {
+				x: 4,
+				y: 4,
+				width: 46,
+				height: 16,
+				onClick: this._onNameClick.bind(this),
+			}, [
+				DOM.h('span', {
+					class: 'group-name',
+					innerText: this.name,
+				}),
+			]),
+			// symbol
+			DOM.s('text', {
+				class: 'group-symbol',
+				x: 10,
+				y: 60,
+			}, [
+				DOM.t(this.symbol[0]),
+			]),
+			// dissolve button
+			DOM.s('g', {
+				class: 'button dissolve-button',
+				onClick: this._onDissolveClick.bind(this),
+			}, [
+				DOM.s('rect', {
+					rx: 4,
+					ry: 4,
+					x: 54,
+					y: 4,
+					height: 14,
+					width: 14,
+				}),
+				DOM.s('line', {
+					x1: 57,
+					y1: 7,
+					x2: 65,
+					y2: 15,
+				}),
+				DOM.s('line', {
+					x1: 65,
+					y1: 7,
+					x2: 57,
+					y2: 15,
+				}),
+			]),
+		]);
+
+		// symbol list
+		this._symbolListComponent = new NodeSymbolList;
+		this._rootElement.appendChild(this._symbolListComponent.render());
+
+		this._symbolList.forEach(symbol => {
+			this._symbolListComponent.appendChild(symbol);
 		});
-		rootElement.addEventListener('click', click.bind(this));
-		rootElement.addEventListener('mousedown', mouseDown.bind(this));
-
-		rootElement.appendChild(DOM.createSvgElement('rect', {
-			'width': size.width,
-			'height': size.height,
-			'x': 1,
-			'y': 1,
-			'fill': this.symbol[1],
-			'stroke': 'black',
-			'stroke-width': 1,
-		}));
-
-		// name
-		var nameTextInner = DOM.createHtmlElement('span', {
-			'class': 'group-name',
-		});
-		nameTextInner.appendChild(DOM.createTextElement(this.name));
 
-		var nameText = DOM.createSvgElement('foreignObject', {
-			'x': 4,
-			'y': 4,
-			'width': 46,
-			'height': 16,
-		});
-		nameText.appendChild(nameTextInner);
-		nameText.addEventListener('click', nameClick.bind(this));
-		rootElement.appendChild(nameText);
-
-		// symbol
-		var symbolText = DOM.createSvgElement('text', {
-			'class': 'group-symbol',
-			'x': 10,
-			'y': 60,
-		});
-		symbolText.appendChild(document.createTextNode(this.symbol[0]));
-		rootElement.appendChild(symbolText);
-
-		// dissolve button
-		var dissolveButton = DOM.createSvgElement('g', {
-			'class': 'button dissolve-button',
-		});
-		dissolveButton.appendChild(DOM.createSvgElement('rect', {
-			'rx': 4,
-			'ry': 4,
-			'x': 54,
-			'y': 4,
-			'height': 14,
-			'width': 14,
-		}));
-		dissolveButton.appendChild(DOM.createSvgElement('line', {
-			'x1': 57,
-			'y1': 7,
-			'x2': 65,
-			'y2': 15,
-		}));
-		dissolveButton.appendChild(DOM.createSvgElement('line', {
-			'x1': 65,
-			'y1': 7,
-			'x2': 57,
-			'y2': 15,
-		}));
-		dissolveButton.addEventListener('click', dissolveClick.bind(this));
-		rootElement.appendChild(dissolveButton);
-
-		return rootElement;
+		return this._rootElement;
 	}
 
 	/**
-	 * @returns {Element} HTML DOM element.
+	 * @returns {HTMLElement} HTML DOM element.
 	 */
-	function renderExcluded() {
-		rootElement = DOM.createHtmlElement('li', {
-			'class': 'node group',
-			'data-id': this.id,
+	_renderExcluded() {
+		const svg = DOM.s('svg', {
+			xmlns: 'http://www.w3.org/2000/svg',
+			height: 60,
+			width: 46,
 		});
 
-		var svg = DOM.createSvgElement('svg', {
-			'xmlns': 'http://www.w3.org/2000/svg',
-			'height': 60,
-			'width': 46,
-		});
-		rootElement.appendChild(svg);
-
 		// related archetypes
-		var relatedArchetypesGroup = DOM.createSvgElement('g', {
-			'transform': 'translate(10, 15)',
+		const relatedArchetypesGroup = DOM.s('g', {
+			transform: 'translate(10, 15)',
 		});
 		svg.appendChild(relatedArchetypesGroup);
 
-		var archetypeIconOrder = 0;
-		for (var archetypeIndex in relatedArchetypeMap) {
-			var relatedArchetype = DOM.createSvgElement('g', {
-				'class': 'related-archetype',
-				'transform': `translate(0, ${archetypeIconOrder * 20})`,
-			});
-			relatedArchetypesGroup.appendChild(relatedArchetype);
-
-			// counter
-			var relatedArchetypeCounter = DOM.createSvgElement('text');
-			relatedArchetypeCounter.appendChild(DOM.createTextElement(relatedArchetypeMap[archetypeIndex]));
-			relatedArchetype.appendChild(relatedArchetypeCounter);
-
-			// icon
-			var relatedArchetypeIcon = DOM.createSvgElement('use', {
-				'href': '#vertexArchetypeIcon-' + app.archetype.vertex[archetypeIndex].name,
-				'class': 'archetype-icon',
-				'transform': `translate(15, -10)`,
-			});
-			relatedArchetypeIcon.addEventListener('click', relatedArchetypeClick.bind(this, parseInt(archetypeIndex))); // TODO when icon == null can not click on item
-			relatedArchetype.appendChild(relatedArchetypeIcon);
-
-			// line
-			relatedArchetype.appendChild(DOM.createSvgElement('line', {
-				'x1': 30,
-				'y1': -5,
-				'x2': 36,
-				'y2': -5,
-			}));
+		let archetypeIconOrder = 0;
+		for (let archetypeIndex in this.relatedArchetypeMap) {
+			relatedArchetypesGroup.appendChild(DOM.s('g', {
+				class: 'related-archetype',
+				transform: `translate(0, ${archetypeIconOrder * 20})`,
+			}, [
+				// counter
+				DOM.s('text', {}, [
+					DOM.t(this.relatedArchetypeMap[archetypeIndex]),
+				]),
+				// icon
+				DOM.s('use', {
+					href: '#vertexArchetypeIcon-' + app.archetype.vertex[archetypeIndex].name,
+					class: 'archetype-icon',
+					transform: `translate(15, -10)`,
+					onClick: this._onRelatedArchetypeIconClick.bind(this, parseInt(archetypeIndex)), // TODO when icon == null can not click on item
+				}),
+				// line
+				DOM.s('line', {
+					x1: 30,
+					y1: -5,
+					x2: 36,
+					y2: -5,
+				}),
+			]));
 
 			archetypeIconOrder++;
 		}
 
-		// symbol
-		var symbolText = DOM.createHtmlElement('span', {
-			'class': 'group-symbol',
-			'style': 'background-color: ' + this.symbol[1] + ';',
-			'x': 10,
-			'y': 55,
-		});
-		symbolText.appendChild(document.createTextNode(this.symbol[0]));
-		symbolText.addEventListener('click', click.bind(this));
-		rootElement.appendChild(symbolText);
-
-		// name
-		var nameText = DOM.createHtmlElement('span', {
-			'class': 'group-name',
-		});
-		nameText.appendChild(document.createTextNode(this.name));
-		nameText.addEventListener('click', nameClick.bind(this));
-		rootElement.appendChild(nameText);
-
 		// vertex list
-		vertexListComponent = new GroupVertexList(this);
-		rootElement.appendChild(vertexListComponent.render());
-
-		vertexList.forEach(function(vertex) {
-			vertexListComponent.appendChild(vertex);
-		}, this);
+		this._vertexListComponent = new GroupVertexList(this);
 
-		// buttons
-		var buttonGroup = DOM.createHtmlElement('div', {
-			'class': 'button-group',
-		});
-		rootElement.appendChild(buttonGroup);
-
-        // show symbol button
-        var showSymbolButton = DOM.createHtmlElement('button', {
-            'class': 'show-symbol-button button',
-            'style': 'background-color: ' + this.symbol[1] + ';',
-            'title': 'Show symbol next to all neighbouring components',
-        });
-        showSymbolButton.appendChild(document.createTextNode(this.symbol[0]));
-        showSymbolButton.addEventListener('click', showIconClick.bind(this));
-        buttonGroup.appendChild(showSymbolButton);
-
-		// include button
-		var includeButton = DOM.createHtmlElement('button', {
-			'class': 'include-button button',
-			'title': 'Display group in viewport',
-		});
-		includeButton.appendChild(DOM.createHtmlElement('img', {
-			'src': 'images/button_cancel.png',
-			'alt': 'Icon of "display group in viewport" action',
-		}));
-		includeButton.addEventListener('click', includeClick.bind(this));
-		buttonGroup.appendChild(includeButton);
+		// root
+		this._rootElement = DOM.h('li', {
+			class: 'node group',
+			'data-id': this.id,
+		}, [
+			svg,
+			// symbol
+			DOM.h('span', {
+				class: 'group-symbol',
+				style: 'background-color: ' + this.symbol[1] + ';',
+				x: 10,
+				y: 55,
+				innerText: this.symbol[0],
+				onClick: this._onNodeClick.bind(this),
+			}),
+			// name
+			DOM.h('span', {
+				class: 'group-name',
+				innerText: this.name,
+				onClick: this._onNameClick.bind(this),
+			}),
+			// vertex list
+			this._vertexListComponent.render(),
+			// buttons
+			DOM.h('div', {
+				class: 'button-group',
+			}, [
+				// show symbol button
+				DOM.h('button', {
+					class: 'show-symbol-button button',
+					style: 'background-color: ' + this.symbol[1] + ';',
+					title: 'Show symbol next to all neighbouring components',
+					innerText: this.symbol[0],
+					onClick: this._onShowNeighbourIconsClick.bind(this),
+				}),
+				// include button
+				DOM.h('button', {
+					class: 'include-button button',
+					title: 'Display group in viewport',
+					onClick: this.include.bind(this),
+				}, [
+					DOM.h('img', {
+						src: 'images/button_cancel.png',
+						alt: 'Icon of "display group in viewport" action',
+					}),
+				]),
+			]),
+		]);
 
 		// set floater
-		floater.setElement(rootElement);
+		this._proxy.setElement(this._rootElement);
 
 		// set edges' ends
-		var inEdgeList = this.getInEdgeList();
-		inEdgeList.forEach(function(edge) {
-			floater.addInEdge(edge);
+		let inEdgeList = this.inEdgeList;
+		inEdgeList.forEach(edge => {
+			this._proxy.addInEdge(edge);
 		});
 
-		var outEdgeList = this.getOutEdgeList();
-		outEdgeList.forEach(function(edge) {
-			floater.addOutEdge(edge);
+		let outEdgeList = this.outEdgeList;
+		outEdgeList.forEach(edge => {
+			this._proxy.addOutEdge(edge);
 		});
 
-		return rootElement;
+		return this._rootElement;
 	}
 
-	/**
-	 * Group click interaction. Based on whether the group is excluded and currently selected mouse mode (move, exclude),
-	 * the group is either highlighted or moved within the graph.
-	 */
-	function click() {
-		if (excluded) {
-			this.setHighlightedWithNeighbours(!highlighted);
-			return;
-		}
-
-		if (pan) {
-			pan = false;
-			return;
-		}
-
-		switch (document.modeForm.mode.value) {
-			case 'move':
-				this.setHighlightedWithNeighbours(!highlighted);
-				break;
-
-			case 'exclude':
-				this.exclude.call(this);
-
-				app.sidebarComponent.excludedNodeListComponent.add(this);
-				break;
-		}
-	}
-
-    /**
-	 * Method add or remove highlighting of group and all neighbours.
-     *
-	 * @param newHighlighted true to highlight, false otherwise
-     */
-    this.setHighlightedWithNeighbours = function (newHighlighted) {
-        this.setHighlighted(newHighlighted);
-        this.setHighlightedRequiredNeighbours(highlighted);
-        this.setHighlightedProvidedNeighbours(highlighted);
-
-        prepareHighlighting.call(this);
-        highlightRequiredNeighbours.call(this);
-        highlightProvidedNeighbours.call(this);
-    };
-
 	/**
 	 * Group name click interaction. Reveals a prompt for new group name.
 	 * @param {Event} e Click event.
 	 */
-	function nameClick(e) {
+	_onNameClick(e) {
 		e.stopPropagation();
 
-		var newValue = prompt('Enter new group name:', this.name);
+		let newValue = prompt('Enter new group name:', this.name);
 		if (newValue !== null) {
 			this.name = newValue;
 
-			rootElement.querySelector('.group-name').innerText = this.name;
+			this._rootElement.querySelector('.group-name').innerText = this.name;
 		}
 	}
 
-    /**
-     * Displays symbol of the group next to all nodes that it is connected with.
-     * @param {MouseEvent} e Click event.
-     */
-    function showIconClick(e) {
-        iconsDisplayed = !iconsDisplayed;
-
-        var neighbourList = [];
-
-        this.getInEdgeList().filter(function (edge) {
-            return !edge.getFrom().isExcluded();
-        }).forEach(function (edge) {
-            if (!neighbourList.includes(edge.getFrom())) {
-                neighbourList.push(edge.getFrom());
-            }
-        });
-
-        this.getOutEdgeList().filter(function (edge) {
-            return !edge.getTo().isExcluded();
-        }).forEach(function (edge) {
-            if (!neighbourList.includes(edge.getTo())) {
-                neighbourList.push(edge.getTo());
-            }
-        });
-
-        neighbourList.forEach(function(node) {
-            if (iconsDisplayed) {
-                node.addSymbol(this.symbol);
-            } else {
-                node.removeSymbol(this.symbol);
-            }
-        }, this);
-    }
-
-	/**
-	 * Includes the group back to the viewport.
-	 */
-	function includeClick() {
-		this.include.call(this);
-	}
-
 	/**
 	 * Dissolves the group so that its vertices are displayed separately again. The group itself is destroyed.
 	 * @param {Event} e Click event.
 	 */
-	function dissolveClick(e) {
-		e.stopPropagation();
-
-		this.remove.call(this, false);
-
-		var vertexListCopy = vertexList.slice(0);
-		vertexListCopy.forEach(function(vertex) {
-			this.removeVertex.call(this, vertex);
-		}, this);
-
-		app.viewportComponent.removeGroup(this);
-
-		app.groupList.splice(app.groupList.indexOf(this), 1);
-	}
-	
-	/**
-	 * Archetype icon click interaction. Toggles highlighting of neighbour vertices which are instances of a vertex archetype.
-	 * @param {integer} archetypeIndex Index of the vertex archetype.
-	 * @param {MouseEvent} e Click event.
-	 */
-	function relatedArchetypeClick(archetypeIndex, e) {
-		e.stopPropagation();
-
-		this.setHighlighted(!highlighted);
-		this.setHighlightedArchetypeNeighbours(highlighted);
-
-		prepareHighlighting.call(this);
-		highlightArchetypeNeighbours.call(this, archetypeIndex);
-	}
-	
-	/**
-	 * Handles drag and drop interaction with the group. At the moment mouse button is pressed, it is not yet known whether 
-	 * it is just clicked or dragged.
-	 * @param {Event} e Mouse down event.
-	 */
-	function mouseDown(e) {
+	_onDissolveClick(e) {
 		e.stopPropagation();
-		app.closeFloatingComponents();
-		
-		var self = this;
-		var start = new Coordinates(e.clientX, e.clientY);
-		
-		rootElement.classList.add('node--dragged');
-		
-		document.body.addEventListener('mousemove', mouseMove);
-		document.body.addEventListener('mouseup', mouseUp);
-		document.body.addEventListener('mouseleave', mouseUp);
-		
-		/**
-		 * At the moment mouse is moved, the group is clearly being dragged. The group is moved to the current position of mouse.
-		 * @param {Event} e Mouse move event.
-		 */
-		function mouseMove(e) {
-			pan = true;
-			
-			self.move(new Coordinates(
-				position.x - (start.x - e.clientX) / app.zoom.scale,
-				position.y - (start.y - e.clientY) / app.zoom.scale,
-			));
-		}
-
-		/**
-		 * At the moment mouse button is released, dragging is done and its final position is set to the group.
-		 * @param {Event} e Mouse up event.
-		 */
-		function mouseUp(e) {
-			self.setPosition(new Coordinates(
-				+rootElement.getAttribute('x'),
-				+rootElement.getAttribute('y'),
-			));
-			
-			rootElement.classList.remove('node--dragged');
-			
-			document.body.removeEventListener('mousemove', mouseMove);
-			document.body.removeEventListener('mouseup', mouseUp);
-			document.body.removeEventListener('mouseleave', mouseUp);
-		}
-	}
-	
-	/**
-	 * Prepares highlighting of all graph components so that only the wished ones need to be modified.
-	 */
-	function prepareHighlighting() {
-		this.setDimmed(false);
-
-		this.setHighlightedRequired(false);
-		this.setHighlightedProvided(false);
-		this.setHighlightedArchetype(false);
-
-		if (highlighted) {
-			// dim and unhighlight all nodes but this
-			app.nodeList.forEach(function(node) {
-				if (node === this) return;
-
-				node.setDimmed(true);
-
-				node.setHighlighted(false);
-				node.setHighlightedRequired(false);
-				node.setHighlightedProvided(false);
-				node.setHighlightedArchetype(false);
-			}, this);
-
-			// dim and unhighlight all edges
-			app.edgeList.forEach(function(edge) {
-				edge.setDimmed(true);
-
-				edge.setHighlighted(false);
-				edge.setHighlightedRequired(false);
-				edge.setHighlightedProvided(false);
-			});
-
-		} else {
-			app.nodeList.forEach(function(node) {
-				if (node === this) return;
-
-				node.setDimmed(false);
-
-				node.setHighlighted(false);
-				node.setHighlightedRequired(false);
-				node.setHighlightedProvided(false);
-				node.setHighlightedArchetype(false);
-			}, this);
-
-			app.edgeList.forEach(function(edge) {
-				edge.setHidden(edge.getFrom().isExcluded() || edge.getTo().isExcluded());
-
-				edge.setDimmed(false);
-
-				edge.setHighlighted(false);
-				edge.setHighlightedRequired(false);
-				edge.setHighlightedProvided(false);
-			});
-		}
-	}
-
-	/**
-	 * Highlights only neighbours of vertices in the group that are required.
-	 */
-	function highlightRequiredNeighbours() {
-		if (highlightedRequiredNeighbours === false) return;
-
-		this.getInEdgeList().forEach(function(edge) {
-			edge.setHidden(false);
-
-			edge.getFrom().setDimmed(false);
-			edge.setDimmed(false);
-
-			edge.setHighlightedRequired(true);
-			edge.getFrom().setHighlightedRequired(true);
-		});
-	}
-
-	/**
-	 * Highlights only neighbours of vertices in the group that are provided.
-	 */
-	function highlightProvidedNeighbours() {
-		if (highlightedProvidedNeighbours === false) return;
 
-		this.getOutEdgeList().forEach(function(edge) {
-			edge.setHidden(false);
-
-			edge.setDimmed(false);
-			edge.getTo().setDimmed(false);
-
-			edge.setHighlightedProvided(true);
-			edge.getTo().setHighlightedProvided(true);
-		});
-	}
-
-	/**
-	 * Highlights only neighbours of the group that are instances of the archetype.
-	 * @param {integer} archetypeIndex Index of the vertex archetype.
-	 */
-	function highlightArchetypeNeighbours(archetypeIndex) {
-		if (highlightedArchetypeNeighbours === false) return;
-
-		this.getInEdgeList().filter(function(edge) {
-			return edge.getFrom().archetype === archetypeIndex;
-		}).forEach(function(edge) {
-			edge.setHidden(false);
-
-			edge.setDimmed(false);
-			edge.getFrom().setDimmed(false);
+		this.remove(false);
 
-			edge.getFrom().setHighlightedArchetype(true);
+		let vertexListCopy = this._vertexList.slice(0);
+		vertexListCopy.forEach(vertex => {
+			this.removeVertex(vertex);
 		});
 
-		this.getOutEdgeList().filter(function(edge) {
-			return edge.getTo().archetype === archetypeIndex;
-		}).forEach(function(edge) {
-			edge.setHidden(false);
+		app.viewportComponent.removeNode(this);
 
-			edge.setDimmed(false);
-			edge.getTo().setDimmed(false);
-
-			edge.getTo().setHighlightedArchetype(true);
-		});
+		app.groupList.splice(app.groupList.indexOf(this), 1);
 	}
 }
diff --git a/sources/src/main/webapp/js/components/groupVertexList.js b/sources/src/main/webapp/js/components/groupVertexList.js
index 4453b09..66bb8c1 100644
--- a/sources/src/main/webapp/js/components/groupVertexList.js
+++ b/sources/src/main/webapp/js/components/groupVertexList.js
@@ -20,7 +20,7 @@ class GroupVertexList {
 	 * @returns {Element} HTML or SVG DOM element depending on whether the group is excluded.
 	 */
 	render() {
-		if (this._group.isExcluded()) {
+		if (this._group.isExcluded) {
 			this._rootElement = DOM.h('ul');
 		} else {
 			this._rootElement = DOM.s('g', {
@@ -28,6 +28,11 @@ class GroupVertexList {
 			});
 		}
 
+		let vertexList = this._group.vertexList;
+		vertexList.forEach(vertex => {
+			this.appendChild(vertex);
+		});
+
 		this._rootElement.setAttribute('class', 'group-vertex-list');
 
 		return this._rootElement;
@@ -40,7 +45,7 @@ class GroupVertexList {
 	 */
 	appendChild(vertex) {
 		let listItemElement;
-		if (this._group.isExcluded()) {
+		if (this._group.isExcluded) {
 			listItemElement = DOM.h('li');
 		} else {
 			listItemElement = DOM.s('text', {
diff --git a/sources/src/main/webapp/js/components/navbar.js b/sources/src/main/webapp/js/components/navbar.js
index 5a2351d..c7b29d4 100644
--- a/sources/src/main/webapp/js/components/navbar.js
+++ b/sources/src/main/webapp/js/components/navbar.js
@@ -137,12 +137,12 @@ class Navbar {
 
 			var found = 0;
 			
-			app.viewportComponent.nodeList.forEach(function(node) {
+			app.viewportComponent.getNodeList().forEach(node => {
 				if (node.name.toLowerCase().includes(term.toLowerCase())) {
-					node.setFound(true);
+					node.isFound = true;
 					found++;
 				} else {
-					node.setFound(false);
+					node.isFound = false;
 				}
 			});
 
@@ -150,8 +150,8 @@ class Navbar {
 		}
 
 		function resetSearch() {
-			app.viewportComponent.nodeList.forEach(function(node) {
-				node.setFound(false);
+			app.viewportComponent.getNodeList().forEach(node => {
+				node.isFound = false;
 			});
 
 			searchInput.value = '';
@@ -257,7 +257,7 @@ class Navbar {
 					});
 
 					if (verticesWithMostEdges.length > 0) {
-						var group = new Group({});
+						let group = Group.create();
 
 						verticesWithMostEdges.forEach(function(vertex) {
 							group.addVertex(vertex);
@@ -266,7 +266,7 @@ class Navbar {
 						app.nodeList.push(group);
 						app.groupList.push(group);
 
-						app.viewportComponent.addGroup(group);
+						app.viewportComponent.addNode(group);
 					}
 				},
 			}, [
